SLASH_BUFFTIMERS1 = "/bufftimers"
SLASH_BUFFTIMERS2 = "/bt"

if (not BuffTimersOptions) then
    BuffTimersOptions = {}
    BuffTimersOptions["seconds"] = false
end

SlashCmdList["BUFFTIMERS"] = function(msg)
    msg = string.lower(msg)

    print(msg)

    if msg == "seconds" then
        BuffTimersOptions["seconds"] = not BuffTimersOptions["seconds"]
    end
end

local function formatTime(time)
    local minutes = ceil(time / 60)
    local seconds = mod(time, 60)

    if minutes >= 2 then
        if BuffTimersOptions["seconds"] then
            return ("%d:%d"):format(minutes, seconds)
        else
            return ("%dm"):format(minutes)
        end
    else
        return ("%ds"):format(seconds)
    end
end

local function onAuraDurationUpdate(aura, time)   
    local duration = getglobal(aura:GetName().."Duration")
    
    if (time) then
        duration:SetText(formatTime(time))
        duration:Show()
    else
        duration:Hide()
    end
end

local function onAuraUpdate(auraSlot, index, filter)
    local auraName = auraSlot..index
    local aura = getglobal(auraName)
    local auraDuration = getglobal(auraName.."Duration")
    
    if not auraDuration then
        return
    end

    local name, _, _, _, _, expirationTime = UnitAura("player", index, filter)
    
    if (name and (not expirationTime or expirationTime == 0)) then
        auraDuration:Show()
    else
        auraDuration:Hide()
    end
end

-- Add or remove aura event
hooksecurefunc("AuraButton_Update", onAuraUpdate)

-- Aura duration update event
hooksecurefunc("AuraButton_UpdateDuration", onAuraDurationUpdate)
